hdu 1069 Monkey and Banana 再来一波DP啦~~LIS的变形,会最大上

Monkey and BananaTime Limit: 2000/1000 MS (Java/Others)Memory Limit: 65536/32768 K (Java/Others)Total Submission(s): 8260Accepted Submission(s): 4262

Problem Description

A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn’t be stacked.Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.

Input

The input file will contain one or more test cases. The first line of each test case contains an integer n,representing the number of different blocks in the following data set. The maximum value for n is 30.Each of the next n lines contains three integers representing the values xi, yi and zi.Input is terminated by a value of zero (0) for n.

Output

For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".

Sample Input

110 20 3026 8 105 5 571 1 12 2 23 3 34 4 45 5 56 6 67 7 7531 41 5926 53 5897 93 2384 62 6433 83 270

Sample Output

Case 1: maximum height = 40Case 2: maximum height = 21Case 3: maximum height = 28Case 4: maximum height = 342

最近一直在搞DP,也写了不少博客,,感觉大家对这方面没什么兴趣,,关于DP的题解访问量也比较低~~~可能是我写的太渣了吧o(╯□╰)o

反正刚开始看不太懂题目,搜题解的大家都说这题简单,顿时感觉天都黑了!!!!!!题解中都提到了最大上升字串,所以我又用了一天的时间看了最大上升子序列,最长上升子序列,最长公共上升子序列,反正各种痛苦啊!!!看完后感觉受益匪浅,A了很多题,感觉时机差不多了,,就重新来做这题了。做这题时,首先要按照长和宽排序,至于为什么呢,题目不是要求最大字串吗,这应该算是贪心吧。

然后就是状态转移公式了dp[i] = max(dp[k]+p[i].z,dp[i]) (k<i&& p[i].x<p[k].x && p[i].y<p[k].y);状态转移公式后面的条件与你排序有关,,我是按照从长从大到小,长相等,宽从大到小排序的。

下面代码:

画龙画虎难画骨,知人知面不知心。

hdu 1069 Monkey and Banana 再来一波DP啦~~LIS的变形,会最大上

相关文章:

你感兴趣的文章:

标签云: